<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { onMounted, onUnmounted, ref, watch, inject, computed } from 'vue';
import { storeToRefs } from 'pinia';
import { useRoute, useRouter } from 'vue-router';
import { useClipboard, useTitle } from '@vueuse/core';
import Input from '@/components/general/form/Input.vue';
import Button from '@/components/general/Button.vue';
import ChatAnswer from '@/components/chat/ChatAnswer.vue';
import ChatAnswerError from '@/components/chat/ChatAnswerError.vue';
import ChatImageAnswer from '@/components/chat/ChatImageAnswer.vue';
import SSEAnswer from '@/components/chat/ChatAnswerSSE.vue';
import LoadingChatImage from '@/components/chat/ChatLoadingImage.vue';
import { request } from '@/lib/request';
import { useAccountStore } from '@/stores/account';
import { useChatStore } from '@/stores/chat';
import ChatInformation from '@/components/chat/ChatInformation.vue';
import ChatExportModal from '@/components/chat/ChatExportModal.vue';
import { notificationStatus } from '@/enums/enums';
import { useBaseStore } from '@/stores/base';
import { useI18n } from 'vue-i18n';
import Modal from '@/components/general/Modal.vue';

const { t } = useI18n();
const $t = t;
const { copy } = useClipboard();
const route = useRoute();
const router = useRouter();
const configuration = inject<any>('configuration');
const baseStore = useBaseStore();
const { message, status } = storeToRefs(baseStore);
const chatStore: any = useChatStore();
const { tab, userType, username, chatTitle, activeChatUuid, isShared, loadMessage, loadImage, reloadMessages } = storeToRefs(chatStore);
const { getChats } = chatStore;
const avatar = ref('');
const messages = ref<{ user: string, message: string, meta?: any }[]>([]);
const chatMessage = ref('');
const sseId = ref('');
//const loadMessage = ref(false);
//const loadImage = ref(false);
const initialLoading = ref(true);
const accountStore = useAccountStore();
const { mail } = storeToRefs(accountStore);
const type = ref('');
const showScrollButton = ref(false);
const userId = route.params.user_uuid;
const chatId = route.params.uuid as string;

const observer = ref<MutationObserver | null>(null);
const observerActive = ref(true)

const newMessages = ref(false);

const title = useTitle();
title.value = chatTitle.value;

let intervalId: any;

// Checks if little arrow at bottom should be visible for shortcut to bottom and checks if observer for auto scroll should be active
const checkScrollPosition = () => {
    const contentElement = contentRef.value;
    if (contentElement) {
        const scrollTop = contentElement.scrollTop;
        const scrollHeight = contentElement.scrollHeight;
        const clientHeight = contentElement.clientHeight;
        showScrollButton.value = scrollTop + clientHeight + 300 < scrollHeight;
        if (!(contentElement.scrollTop + contentElement.offsetHeight >= contentElement.scrollHeight - 30)) {
            observerActive.value = false;
        } else {
            observerActive.value = true;
            newMessages.value = false;
        }
    }

};

const option = ref('');
const handleFinishedMessage = async (message: string) => {
    loadMessage.value = false;
    const newMessage = { user: 'system', message: message } as { user: string, message: string, meta?: any };
    if (option.value !== "") {
        newMessage.meta = { option: option.value };
    }
    messages.value.push(newMessage);
    option.value = "";
    if (mail.value) await getChats();
};

const handleSendMessage = async () => {
    option.value = "";
    if (chatMessage.value.length > 0) {
        const data = { message: chatMessage.value, user: username.value };
        const isSecure = userType.value !== 'user';
        if (!loadImage.value && !loadMessage.value && isShared.value) {
            const uuid = route.params.uuid;
            const result = await request('PUT', configuration.apiServer + "/api/ai/chat/" + uuid + "/message", data, 'application/json', undefined, isSecure);
            if (result.success) {
                if (result.message && result.message === "Tokens exceeded") {
                    message.value = $t('ai.chat.notification.error.noTokens');
                    status.value = notificationStatus.DANGER;
                    isShared.value = false;
                } else {
                    if (type.value !== 'image') {
                        if (activeChatUuid.value === "" || uuid === activeChatUuid.value) {
                            messages.value.push({ user: 'user', message: chatMessage.value });
                            sseId.value = result.uuid;
                            loadMessage.value = true;
                        }
                    }
                    else {
                        messages.value.push({ user: 'user', message: chatMessage.value });
                        loadImage.value = true;
                        chatMessage.value = '';
                        const imageResult = await request('GET', configuration.aiServer + '/chat/image/' + result.uuid, undefined, 'application/json', undefined, isSecure);
                        if (imageResult.success) {
                            if (activeChatUuid.value === "" || uuid === activeChatUuid.value) {
                                messages.value.push({ user: 'system', message: imageResult.message });
                                loadImage.value = false;
                                if (isSecure) await getChats();
                            }
                        } else {
                            if (imageResult.status === 400) {
                                message.value = $t('ai.image.error.badRequest');
                            } else {
                                message.value = $t('ai.image.error.generate');
                            }
                            status.value = notificationStatus.DANGER;
                            loadImage.value = false;
                        }
                        getChat();
                    }
                }
            }
        }
        chatMessage.value = '';
    }
};

const handleSendOption = async (value: string) => {
    if (isShared.value) {
        const data = { message: "", user: username.value, option: value };
        option.value = value;
        const isSecure = userType.value !== 'user';
        if (!loadMessage.value && !loadImage.value) {
            const uuid = route.params.uuid;
            const result = await request('PUT', configuration.apiServer + "/api/ai/chat/" + uuid + "/message", data, 'application/json', undefined, isSecure);
            if (result.success) {
                if (result.message && result.message === "Tokens exceeded") {
                    message.value = $t('ai.chat.notification.error.noTokens');
                    status.value = notificationStatus.DANGER;
                    isShared.value = false;
                } else {
                    sseId.value = result.uuid;
                    loadMessage.value = true;
                }
            }
        }
    }
};

const handleCreateImageVariation = async (image: string) => {
    if (isShared.value) {
        const formData = new FormData();
        formData.append('file', image);
        formData.append('user', username.value);
        const data = { message: "", user: username.value, option: 'variation' };
        const isSecure = userType.value !== 'user';
        if (!loadImage.value && !loadMessage.value) {
            if (mail.value) {
                const uuid = route.params.uuid;
                const result = await request('PUT', configuration.apiServer + "/api/ai/chat/" + uuid + "/message", data, 'application/json', undefined, isSecure);
                if (result.success) {
                    if (result.message && result.message === "Tokens exceeded") {
                        message.value = $t('ai.chat.notification.error.noTokens');
                        status.value = notificationStatus.DANGER;
                        isShared.value = false;
                    } else {
                        loadImage.value = true;
                        const imageResult = await request('POST', configuration.aiServer + '/chat/image/' + result.uuid + '/variation', formData, 'multipart/form-data', undefined, isSecure);
                        if (imageResult.success) {
                            messages.value.push({ user: 'system', message: imageResult.message });
                            loadImage.value = false;
                        }
                        if (isSecure) await getChats();
                    }
                }
            }
        }
    }
};

const handleCreateImageImpainting = async (image: string, mask: string, prompt: string) => {
    if (isShared.value) {
        const formData = new FormData();
        formData.append('file', image);
        formData.append('mask', mask);
        const data = { message: prompt, user: username.value, option: 'impainting' };
        const isSecure = userType.value !== 'user';
        if (!loadImage.value && !loadMessage.value) {
            if (mail.value) {
                const uuid = route.params.uuid;
                const result = await request('PUT', configuration.apiServer + "/api/ai/chat/" + uuid + "/message", data, 'application/json', undefined, isSecure);
                if (result.success) {
                    if (result.message && result.message === "Tokens exceeded") {
                        message.value = $t('ai.chat.notification.error.noTokens');
                        status.value = notificationStatus.DANGER;
                        isShared.value = false;
                    } else {
                        loadImage.value = true;
                        const imageResult = await request('POST', configuration.aiServer + '/chat/image/' + result.uuid + '/impaiting', formData, 'multipart/form-data', undefined, isSecure);
                        if (imageResult.success) {
                            messages.value.push({ user: 'system', message: imageResult.message });
                            loadImage.value = false;
                        }
                        if (isSecure) await getChats();
                    }
                }
            }
        }
    }
};

const createObserver = (element: HTMLElement) => {
    observer.value = new MutationObserver((mutations) => {
        if (observerActive.value) {
            mutations.forEach((mutation) => {
                if (mutation.type === 'childList') {
                    debouncedScrollToBottom();
                }
            });
        }
    });
    observer.value.observe(element, { childList: true, subtree: true });
};

function debounce(func: any, wait: any) {
    let timeout: any;
    return function (...args: any) {
        //@ts-ignore
        const context = this;
        clearTimeout(timeout);
        timeout = setTimeout(() => {
            func.apply(context, args);
        }, wait);
    };
}

const contentRef = ref();

onMounted(async () => {
    messages.value = [];
    setTimeout(() => {
        getChat();

    }, 10);
    intervalId = setInterval(getChat, 300000);
    const contentElement = contentRef.value;
    if (contentElement) {
        createObserver(contentElement);
    }
    setTimeout(() => { scrollToBottom(); }, 1000);
});

onUnmounted(() => {
    if (intervalId) {
        clearInterval(intervalId);
    }
    if (observer.value) {
        observer.value.disconnect();
    }
});


watch(() => route.params, async () => {
    chatMessage.value = "";
    loadMessage.value = false;
    loadImage.value = false;
    observerActive.value = true;
    messages.value = [];
    initialLoading.value = true;
    setTimeout(() => {
        getChat();

    }, 100);
    //intervalId = setInterval(getChat, 300000);
    setTimeout(() => { scrollToBottom(); }, 1000);
});


setTimeout(() => {
    watch(() => messages, async () => {
        newMessages.value = true;
    }, { deep: true });
}, 5000);


const getChat = async () => {
    const uuid = route.params.uuid;
    let result;
    if (uuid) {
        if (userType.value !== 'user') {
            result = await request('GET', `${configuration.apiServer}/api/ai/chat/${uuid}?messages=true`, undefined, 'application/json', undefined, true);
        } else {
            result = await request('GET', `${configuration.apiServer}/api/ai/chat/${uuid}/${username.value}`, undefined, 'application/json', undefined, false);
        }
        if (result.success) {
            initialLoading.value = false;
            avatar.value = result.chat?.avatar ?? '';
            type.value = result.chat.type;
            messages.value = [];
            messages.value = messages.value.length === 0 ? result.messages : messages.value;
            description.value = result.chat.person_description ?? '';
            systemprompt.value = result.chat.system_prompt ?? '';
            model.value = result.chat.model ?? '';
            userMail.value = result.chat.user_mail ?? '';
            chatTitle.value = result.chat.name;
            chatMeta.value = result.chat.meta;
            if (userType.value === 'user') {
                isShared.value = result.isShared !== undefined ? result.isShared : isShared.value;
            }
        } else {
            router.push({ path: userType.value !== 'user' ? '/overview/chat' : '/' });
        }
    }
};

const scrollToBottom = () => {
    const element = contentRef.value;
    if (element) {
        element.scrollTo({
            top: element.scrollHeight,
            behavior: 'smooth',
        });
    }
};

const debouncedScrollToBottom = debounce(scrollToBottom, 10); // 100ms Verzögerung
const model = ref('');
const systemprompt = ref('');
const description = ref('');
const userMail = ref('');
const chatMeta = ref(null);

watch(() => route.params.uuid, (newValue, oldValue) => {
    if (newValue !== oldValue)
        initialLoading.value = true;
});

watch(() => chatTitle.value, (newValue, oldValue) => {
    title.value = newValue;
});

const handleGoToChatOverview = () => {
    activeChatUuid.value = "";
    router.push({ name: 'chat-overview' });
};

const showExportModal = ref(false);
const handleShowExportModal = () => {
    showExportModal.value = true;
};

const handleCloseExportModal = () => {
    showExportModal.value = false;
};


const showExpandModal = ref(false);
const handleExpandInput = () => {
    showExpandModal.value = true;
};

const handleCloseExpandModal = () => {
    showExpandModal.value = false;
};

const handleSendAndClose = () => {
    handleCloseExpandModal();
    handleSendMessage();
};

watch(() => reloadMessages.value, (newValue, oldValue) => {
    if (newValue === true && oldValue === false) {
        getChat();
        reloadMessages.value = false;
    };
});

const handleCopyUrl = () => {
    copy(window.location.href);
    message.value = $t('ai.chat.share.url.notification');
};

</script>
<template>
    <div class="flex flex-col gap-2 h-full">
        <div class="flex gap-2 justify-between h-8 w-full">
            <div class="w-8 h-8">
                <Tooltip :tooltip="$t('ai.overview.backToOverview.label')" v-if="userId === undefined">
                    <button @click="handleGoToChatOverview"
                        class="hover:bg-gray-300 rounded-md w-8 h-8 leading-8 align-middle text-center text-gray-500 hover:text-gray-700">
                        <i class="ri-home-2-line text-2xl"></i>
                    </button>
                </Tooltip>
            </div>
            <div class="text-center text-2xl justify-self-center line-clamp-1 mx-4 w-full select-none">
                <Tooltip :tooltip="chatTitle">{{ chatTitle }}</Tooltip>
            </div>
            <div class="justify-self-end select-none flex flex-row">
                <Tooltip :tooltip="$t('ai.chat.share.url.tooltip')" v-if="userId !== undefined">
                    <button
                        class="hover:bg-gray-200 rounded-md w-8 h-8 leading-8 align-middle text-center text-blue-700 hover:text-blue-800"
                        @click="handleCopyUrl"><i class="ri-link ri-lg"></i></button>
                </Tooltip>
                <Tooltip :tooltip="$t('ai.overview.item.additionalFunctions.export')" v-if="userId !== undefined">
                    <button
                        class="hover:bg-gray-200 rounded-md w-8 h-8 leading-8 align-middle text-center text-fuchsia-700 hover:text-fuchsia-800"
                        @click="handleShowExportModal"><i class="ri-file-line ri-lg"></i></button>
                </Tooltip>
                <ChatInformation :key="systemprompt + '_' + description" :model="model" :systemprompt="systemprompt"
                    :userMail="userMail" :description="description" :meta="chatMeta" />
            </div>
        </div>
        <div class="flex flex-col gap-2 min-h-[calc(100dvh-13rem)] max-h-[calc(100dvh-13rem)] grow max-w-full overflow-y-auto overflow-x-hidden pr-4 relative"
            id="content" ref="contentRef" @scroll="checkScrollPosition">
            <template v-for="message, index in messages" v-if="!initialLoading || userType === 'user'">
                <template v-if="message && message.meta && message.meta.error">
                    <ChatAnswerError :key="`msg_` + index" :message="message.message" :user="message.user"
                        :isLast="index === (messages.length - 1)" :option="message.meta?.option" :copyHandler="true"
                        :avatar="message.user === 'system' ? avatar : undefined" @option="handleSendOption"
                        :disabled="(message.meta && message.meta.noContext ? true : false)" />
                </template>
                <template v-else>
                    <ChatAnswer :key="`msg_` + index" :message="message.message" :user="message.user"
                        :isLast="index === (messages.length - 1)" :option="message.meta?.option" :copyHandler="true"
                        :avatar="message.user === 'system' ? avatar : undefined" @option="handleSendOption"
                        :disabled="(message.meta && message.meta.noContext ? true : false)"
                        v-if="!message.message.startsWith('/api/file/chats/') && (!message.meta || (message.meta && !message.meta.hide))" />
                    <ChatImageAnswer :key="`img_` + index" :message="message.message" :user="message.user"
                        :isLast="index === (messages.length - 1)"
                        :avatar="message.user === 'system' ? avatar : undefined" :option="message.meta?.option"
                        @variation="handleCreateImageVariation" @impainting="handleCreateImageImpainting"
                        v-else-if="message.message.startsWith('/api/file/chats/')" />
                </template>
                <div class="w-full"
                    v-if="(message.meta && message.meta.noContext === true) && ((messages.length === index + 1 || (messages.length > index + 1) && (!messages[index + 1].meta || (messages[index + 1].meta && !('noContext' in messages[index + 1].meta)))))">
                    <div class="border-2 border-gray-300"></div>
                    <div class="mx-auto px-2 w-fit text-center text-gray-400/80 font-mono -mt-3 bg-gray-100">{{
                        $t('ai.general.variables.noContext.chat.label') }}</div>
                </div>
            </template>
            <div class="rounded-md p-4 w-full" v-if="initialLoading">
                <div class="animate-pulse flex space-x-4">
                    <div class="rounded-full bg-slate-700 h-10 w-10"></div>
                    <div class="flex-1 space-y-6 py-1">
                        <div class="h-2 bg-slate-700 rounded"></div>
                        <div class="space-y-3">
                            <div class="grid grid-cols-3 gap-4">
                                <div class="h-2 bg-slate-700 rounded col-span-2"></div>
                                <div class="h-2 bg-slate-700 rounded col-span-1"></div>
                            </div>
                            <div class="h-2 bg-slate-700 rounded"></div>
                        </div>
                    </div>
                </div>
            </div>

            <div>
                <SSEAnswer :id="sseId" :avatar="avatar" v-if="loadMessage" @close="handleFinishedMessage"
                    :option="option" />
                <LoadingChatImage v-if="loadImage" user="system" :avatar="avatar" />
            </div>
            <button v-if="showScrollButton"
                class="w-fit h-6 bg-white rounded-full py-0.5 px-1 shadow-md sticky bottom-4 left-1/2 transform -translate-x-1/2 "
                @click="scrollToBottom">
                <i class="ri-arrow-down-wide-line"></i>
            </button>

            <div v-if="showScrollButton && newMessages"
                class="animate-ping opacity-75 w-2.5 h-2.5 min-w-2.5 min-h-2.5 bg-accent2-default rounded-full shadow-md sticky bottom-[32.7px] left-[50.55%] transform -translate-y-[20.2%] flex items-center justify-center text-accent2-text text-lg">

            </div>
            <div v-if="showScrollButton && newMessages"
                class="w-3 h-3 bg-accent2-default rounded-full shadow-md sticky bottom-7 left-[50.5%] transform -translate-y-1/3 flex items-center justify-center text-accent2-text text-lg">
                <i class="ri-notification-2-line animate-wiggle" style="font-size:8px;"></i>
            </div>
        </div>
        <div class="flex flex-row gap-2 w-full" v-if="((!initialLoading || userType === 'user') && isShared)">
            <Input v-model="chatMessage" type="text"
                :placeholder="type === 'image' ? $t('ai.chat.send.placeholder.image') : $t('ai.chat.send.placeholder.label')"
                :maxLength="3000" @keyup.enter="handleSendMessage"
                :iconRight="(!loadImage && !loadMessage) ? 'expand-diagonal' : undefined"
                :iconRightMethod="handleExpandInput" />
            <div class="w-fit" role="button">
                <Button :variant="(!loadImage && !loadMessage && chatMessage.length > 0) ? 'accent1' : 'disabled'"
                    @click="handleSendMessage">{{
                        $t("ai.chat.send.button") }}</Button>
            </div>
        </div>
    </div>
    <ChatExportModal :uuid="chatId" :userId="userId as string" @close="handleCloseExportModal"
        v-if="showExportModal && chatId && userId" />
    <Modal v-if="showExpandModal" @cancel="handleCloseExpandModal" labelCancel="Abbrechen" labelSubmit="Senden"
        @submit="handleSendAndClose" :disableSubmit="loadImage || loadMessage || chatMessage.length == 0">
        <textarea
            class="w-full h-full border rounded-md border-gray-300 focus-within:outline-0 focus:outline-0 focus:border-accent1-default p-4 text-gray-500 resize-none min-h-[calc(100dvh-300px)] max-h-[calc(100dvh-300px)]"
            v-model="chatMessage" :maxLength="3000"></textarea>
    </Modal>
</template>
